#include "includes.h"
#include "proxy.h"
#include "misc.h"

static const char cvsid[] = "$Id: proxy.c,v 1.5 2003/03/07 03:21:37 alexcv Exp $";

int
proxy(fd_set *active, fd_set *perm)
{
    Channels *temp;

    temp = chan;
    while (temp != NULL) {
        if (FD_ISSET(temp->source, active)) {
            if (copy_between_ports(temp->source, temp->target) < 0) {
                /* We need better handling here. */
                FD_CLR(temp->source, perm);
                FD_CLR(temp->target, perm);
                if (temp->next == NULL) {
                    chan_remove(temp);
                    return 0;
                } else {
                    temp = temp->next;
                    chan_remove(temp->prev);
                }
            }
        }
        if (FD_ISSET(temp->target, active)) {
            if (copy_between_ports(temp->target, temp->source) < 0) {
                /* We need better handling here. */
                FD_CLR(temp->source, perm);
                FD_CLR(temp->target, perm);
                if (temp->next == NULL) {
                    chan_remove(temp);
                    return 0;
                } else {
                    temp = temp->next;
                    chan_remove(temp->prev);
                }
            }
        }
        temp = temp->next;
    }
    
    return 0;
}

void
chan_remove(Channels *temp)
{

    unregister_sock(temp->source);
    unregister_sock(temp->target);

    close(temp->source);
    close(temp->target);

    if (temp->prev == NULL) {
        if (temp->next == NULL) {
            chan = NULL;
            free(temp);
        } else {
            chan = temp->next;
            chan->prev = NULL;
            free(temp);
        }
    } else {
        if (temp->next == NULL) {
            temp->prev->next = NULL;
            free(temp);
        } else {
            temp->prev->next = temp->next;
            temp->next->prev = temp->prev;
            free(temp);
        }
    }
}

Channels *
chan_add(void)
{
    Channels *temp;

    temp = (Channels *)malloc(sizeof(Channels));
    if (temp == NULL) {
        perror("malloc");
        exit(1);
    }

    memset(temp, 0, sizeof(Channels));

    return temp;
}
